=== modified file 'sql/sql_select.cc'
--- sql/sql_select.cc	2014-10-29 12:20:46 +0000
+++ sql/sql_select.cc	2014-11-03 08:10:05 +0000
@@ -4098,6 +4098,7 @@ make_join_statistics(JOIN *join, List<TA
 typedef struct key_field_t {
   Field		*field;
   Item		*val;			///< May be empty if diff constant
+  Item_func     *cond;
   uint		level;
   uint		optimize;
   bool		eq_func;
@@ -4439,20 +4440,6 @@ add_key_field(JOIN *join,
       }
       if (!eq_func) // eq_func is NEVER true when num_values > 1
         return;
-
-      /*
-	We can't use indexes when comparing a string index to a
-	number or two strings if the effective collation
-        of the operation differ from the field collation.
-       */
-
-      if (field->cmp_type() == STRING_RESULT)
-      {
-        if ((*value)->cmp_type() != STRING_RESULT)
-            return;
-        if (field->charset() != cond->compare_collation())
-          return;
-      }
     }
   }
   /*
@@ -4464,6 +4451,7 @@ add_key_field(JOIN *join,
   (*key_fields)->field=		field;
   (*key_fields)->eq_func=	eq_func;
   (*key_fields)->val=		*value;
+  (*key_fields)->cond=          cond;
   (*key_fields)->level=         and_level;
   (*key_fields)->optimize=      optimize;
   /*
@@ -4905,7 +4893,9 @@ add_key_part(DYNAMIC_ARRAY *keyuse_array
       uint key_parts= form->actual_n_key_parts(keyinfo);
       for (uint part=0 ; part <  key_parts ; part++)
       {
-	if (field->eq(form->key_info[key].key_part[part].field))
+        if (field->eq(form->key_info[key].key_part[part].field) &&
+            field->can_optimize_keypart_ref(keyinfo, key, part,
+                                            key_field->cond, key_field->val))
 	{
           if (add_keyuse(keyuse_array, key_field, key, part))
             return TRUE;
@@ -4916,6 +4906,8 @@ add_key_part(DYNAMIC_ARRAY *keyuse_array
         (key_field->optimize & KEY_OPTIMIZE_EQ) &&
         key_field->val->used_tables())
     {
+      if (!field->can_optimize_hash_join(key_field->cond, key_field->val))
+        return false;
       /* 
         If a key use is extracted from an equi-join predicate then it is
         added not only as a key use for every index whose component can
@@ -12407,7 +12399,7 @@ static bool check_simple_equality(Item *
       else 
       {
         /* None of the fields was found in multiple equalities */
-        Item_equal *item_equal= new Item_equal(orig_left_item,
+        Item_equal *item_equal= new Item_equal(left_field, orig_left_item,
                                                orig_right_item,
                                                FALSE);
         item_equal->set_context_field((Item_field*)left_item);
@@ -12444,20 +12436,26 @@ static bool check_simple_equality(Item *
     {
       bool copyfl;
 
-      if (field_item->cmp_type() == STRING_RESULT)
+      Hybrid_cmp_context cmp;
+      Item *args[2]= {orig_left_item, orig_right_item};
+      if (cmp.set_compare_context("=<mul>=", args, 2))
+      {
+        /*
+          Should not happen, as all comparison arguments (field + const pairs)
+          have previously been checked for compatibility in fix_length_and_dec
+          or their original comparison functions, e.g Item_func_eq.
+        */
+        DBUG_ASSERT(0);
+        return false;
+      }
+
+      if (cmp.compare_type() == STRING_RESULT)
       {
         CHARSET_INFO *cs= field_item->field->charset();
-        if (!item)
-        {
-          Item_func_eq *eq_item;
-          if (!(eq_item= new Item_func_eq(orig_left_item, orig_right_item)) ||
-              eq_item->set_cmp_func())
-            return FALSE;
-          eq_item->quick_fix_field();
-          item= eq_item;
-        }  
-        if ((cs != ((Item_func *) item)->compare_collation()) ||
-            !cs->coll->propagate(cs, 0, 0))
+        CHARSET_INFO *cmpcs= item && item->type() == Item::FUNC_ITEM ?
+                             ((Item_func *) item)->compare_collation() :
+                             cmp.compare_collation();
+        if (cs != cmpcs || !cs->coll->propagate(cs, 0, 0))
           return FALSE;
       }
 
@@ -12480,7 +12478,7 @@ static bool check_simple_equality(Item *
       }
       else
       {
-        item_equal= new Item_equal(const_item, orig_field_item, TRUE);
+        item_equal= new Item_equal(cmp, const_item, orig_field_item, TRUE);
         item_equal->set_context_field(field_item);
         cond_equal->current_level.push_back(item_equal);
       }

=== modified file 'sql/table.h'
--- sql/table.h	2014-09-16 12:03:17 +0000
+++ sql/table.h	2014-11-03 06:45:20 +0000
@@ -1373,6 +1373,11 @@ struct TABLE
     DBUG_VOID_RETURN;
   }
 
+  bool optimize_range(uint idx, uint part) const
+  {
+    return MY_TEST(file->index_flags(idx, part, 1) & HA_READ_RANGE);
+  }
+
   bool update_const_key_parts(COND *conds);
   uint actual_n_key_parts(KEY *keyinfo);
   ulong actual_key_flags(KEY *keyinfo);

